#include "inkey.ch"
#include "fileio.ch"
#include "hbclass.ch"
#include "common.ch"

/* compile: hbmk2 jeff_dll -hbdynvm -gtnul */


/* creating a txt file to prove we entered Harbour function */
FUNCTION TESTHB0()
   SET ALTERNATE TO test0.dat
   SET ALTERNATE ON
   ?
   ? "Inside testhb0()"
   ?
   SET ALTERNATE OFF
   CLOSE ALTERNATE
RETURN NIL

/* creating a txt file to prove we entered Harbour function 
 * this time we include the passed string in the txt file
 * to prove we received it correctly
 */
FUNCTION TESTHB1( stringin )
   SET ALTERNATE TO test1.dat
   SET ALTERNATE ON

   ?
   ? "Inside testhb1() with arg ",stringin
   ?

   SET ALTERNATE OFF
   CLOSE ALTERNATE
RETURN "Returned Value from TESTHB1"


/* --- C level --- */
#pragma BEGINDUMP
#include <stdio.h>
#include <windows.h>
#include <hbvm.h>
#include <hbapi.h>
#include <hbapiitm.h>

/* remove outcomment of next line for debug purpose */
/* #define DEBUG 1 */

static char * szResult = NULL;


BOOL WINAPI DllMain( HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved )
{
   HB_SYMBOL_UNUSED( hinstDLL );
   HB_SYMBOL_UNUSED( lpvReserved );

   switch( fdwReason )
   {
      case DLL_PROCESS_ATTACH:  /* for each new process */
#ifdef DEBUG
         MessageBox( 0, "We're in DLLMain", "1", 0 );
#endif
         hb_vmInit( FALSE );
         break;
      case DLL_PROCESS_DETACH:
         if( szResult )
            hb_xfree( szResult );
         hb_vmQuit();
         break;

      case DLL_THREAD_ATTACH:  /* SAME process, but thread-specific init. */
         break;
      case DLL_THREAD_DETACH:  /* SAME process, but thread-specific cleanup. */
         break;
   }
   return TRUE;
}

HB_EXPORT void fpimport0( const char * szProcName )
{
   hb_itemDoC( szProcName, 0, ( PHB_ITEM * ) 0 );
}

HB_EXPORT char * fpimport1( const char * szProcName, char * szText )
{
    PHB_ITEM pItem;
    PHB_ITEM pResult;
    int iLen, iMax;

    if( szProcName && szText )
    {
       iMax = strlen( szText );
       pItem = hb_itemPutC( NULL, szText );
       pResult = hb_itemDoC( szProcName, 1, pItem );

       if( szResult )  /* easy global static -- not thread safe */
          hb_xfree( szResult );

       if( hb_itemType( pResult ) & HB_IT_STRING )
       {
          szResult = hb_itemGetC( pResult );
          iLen = hb_itemGetCLen( pResult );  /* better as: iLen = strlen( szResult ); */
#ifdef DEBUG
          MessageBox( 0, szResult, "3", 0 );
#endif
       }
       else
       {
          szResult = NULL;
          iLen = 0;
#ifdef DEBUG
          MessageBox( 0, "wrong result, no string", "3", 0 );
#endif
       }

       if( iLen > iMax )
          iLen = iMax;
       if( iLen )
          strncpy( szText, szResult, iLen );

       hb_itemRelease( pItem );
       hb_itemRelease( pResult );
#ifdef DEBUG
       MessageBox( 0, "We returned from Call to TESTHB1 3", "4", 0 );
#endif
    }

    return szResult;
}

#pragma ENDDUMP
